﻿namespace FileMatcher.UIControl
{
    class ShortcutOperation : IOperation
    {
        #region Fields

        public readonly FileInfoEx Replaced;

        public readonly FileInfoEx Target;
        public readonly string ShortcutFileName;

        private FileInfoEx _originalTarget;
        private string _originalShortcutFileName;

        #endregion

        #region Constructors

        public ShortcutOperation(FileInfoEx replaced, FileInfoEx target, string shortcutFileName)
        {
            Replaced = replaced;
            Target = target;
            ShortcutFileName = shortcutFileName;
        }

        #endregion

        #region Methods
        #region IOperation members

        public void Redo()
        {
            _originalShortcutFileName = Replaced.ShortcutName;
            _originalTarget = Replaced.Shortcut;

            Replaced.ShortcutName = ShortcutFileName;
            Replaced.Shortcut = Target;
        }

        public void Undo()
        {
            Replaced.ShortcutName = _originalShortcutFileName;
            Replaced.Shortcut = _originalTarget;
        }

        #endregion
        #endregion
    }
}
